// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Тут будет связь с внешним миром

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <OneWire.h>
#include <EEPROM.h> 

#include "configuration.h"
#include "declarations.h"


#if USE_GSM_WIFI == 1
  void SendWiFi8266()
  {
    switch(flGPRSState)
    {
    case 0:  // Состояние не запущено
      break;
    case 2: // С состояний, соответсвующих отправке GPRS активируем wi-fi соединение
    case 14: 
      flGPRSState=158;
      break;
    case 40: // Состояние 40 - это дозвон до телефона, но у wi-fi телефон не подключен, поэтому просто передаем информацию 
      flGPRSState=158;
      flNeedCall=3; // ставим признак что дозвонились
    case 99:
      if (timeWaitGPRS==0) flGPRSState=98;
      break;
    case 150:
      timeWaitGPRS=10;
      Serial2.println(String(F("AT+CWMODE_CUR=1")).c_str());
      flGPRSState=151;    
    case 151:
      if (timeWaitGPRS==0) flGPRSState=150;
      break;
    case 152:
      // Отключаемся от сети
      timeWaitGPRS=10;
      Serial2.println(String(F("AT+CWQAP")).c_str());
      flGPRSState=153;
    case 153:
      if (timeWaitGPRS==0) flGPRSState=152;
      break;
    case 154:
      // Проверка подключения
      timeWaitGPRS=10;
      Serial2.println(String(F("AT+CIFSR")).c_str());
      flGPRSState=155;
    case 155:
      if (timeWaitGPRS==0) flGPRSState=154;
      break;
    case 168: // Промежуточное состояние - к серверу подключены, идет ожидание OK
      if (timeWaitGPRS==0) flGPRSState=154;
      break;
  
    case 156:
      timeWaitGPRS=10;
      // Подключение
      sprintf(my_gprs_buffer,String(F("AT+CWJAP_CUR=\"%s\",\"%s\"")).c_str(),WiFiAP,WiFiPass);
      Serial2.println(my_gprs_buffer); 
      flGPRSState=157;
    case 157:
      if (timeWaitGPRS==0) flGPRSState=156;
      break;
    case 158:
      timeWaitGPRS=10;
      // проверка соединения с сервером.
      Serial2.println(String(F("AT+CIPSTATUS")).c_str());
      flGPRSState=159;
    case 159:
      if (timeWaitGPRS==0) flGPRSState=158;
      break;
    case 167: // Промежуточное состояние - к серверу подключены, идет ожидание OK
      if (timeWaitGPRS==0) flGPRSState=158;
      break;
    case 160:
      timeWaitGPRS=10;
      if (FlToGSM==10) sprintf(my_gprs_buffer,String(F("AT+CIPSTART=\"UDP\",\"%u.%u.%u.%u\",%u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3],ipPort);
      if (FlToGSM==11) sprintf(my_gprs_buffer,String(F("AT+CIPSTART=\"TCP\",\"%u.%u.%u.%u\",%u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3],ipPort);
      // Подключение
      Serial2.println(my_gprs_buffer);
      flGPRSState=161;
    case 161:
      if (timeWaitGPRS==0) flGPRSState=160;
      break;
    case 162:
      // Отправка
      timeWaitGPRS=10;
      //Serial2.println(String(F("AT+CIPSENDBUF=54")).c_str());
      Serial2.println(String(F("AT+CIPSENDBUF=56")).c_str());
      flGPRSState=163;
    case 163:
      if (timeWaitGPRS==0) flGPRSState=162;
      break;
    case 164:
      timeWaitGPRS=20;
      DisplayData();
      break;
    case 165:
      if (timeWaitGPRS==0) flGPRSState=158;
      // Сообщение отправлено
      break;
    case 180: // Закрываем TCP-UDP соединение и завершаем сеанс
      timeWaitGPRS=10;
      Serial2.println(String(F("AT+CIPCLOSE")).c_str());
      flGPRSState=181;    
    case 181:
      flGPRSState=0; // Ничего не делаем, ждем.
      break;
    default:
      // Если состояние неизвестно, то переходим на инициализацию.
      flGPRSState=98;
      break;
   
    }
  
  }

    void ClearBuffer()
    {
      while (Serial2.available() > 0) Serial2.read();
      pos_rx_buffer=0;
      my_rx_buffer[pos_rx_buffer]=0;
    }

    void GetState()
    {
      int tic1;
      unsigned char hour,minute;
      hour=Seconds / 3600;
      tic1=Seconds % 3600;
      minute=tic1 / 60;
      sprintf(my_tx_buffer,String(F("%02u:%02u I=%3u S=%3u T=%3u,%3u,%3u V=%4u,%4u OFF=%1i,%4uW,U=%3u,%3imm")).c_str(),hour,minute,IspReg, StateMachine,temps[0],temps[1],temps[2],U_VODA,U_UROVEN, (int) flAllOff,UstPower,MaxVoltsOut,U_MPX5010);
    
    }

    void SendGPRS()
    {
      if (FlToGSM==10 || FlToGSM==11)  SendWiFi8266();
    
      switch(flGPRSState)
      {
      case 0:  // Состояние не запущено
        break;

      case 16: // Не Подключено к интернет - посылаем команду подключения к серверу
   
    #ifndef UDP_PROTOKOL     
        sprintf(my_gprs_buffer,String(F("at+tcpsetup=0,%u.%u.%u.%u,%u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3],ipPort);
    #else
        sprintf(my_gprs_buffer,String(F("AT+UDPSETUP=0,%u.%u.%u.%u,%u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3],ipPort);
    #endif
    
        Serial2.println(my_gprs_buffer);
 
        timeWaitGPRS=15;
        flGPRSState=17; // Ничего не делаем, ждем.
      case 17: // Ждем выполнения команды IP
        if (timeWaitGPRS==0) flGPRSState=16;
        break;
           
      case 50: // Закрываем TCP соединение
 
    #ifndef UDP_PROTOKOL     
        Serial2.println(String(F("AT+TCPCLOSE=0")).c_str());
    #else
        Serial2.println(String(F("AT+UDPCLOSE=0")).c_str());
    #endif
    
        timeWaitGPRS=15;
        flGPRSState=51; // Ничего не делаем, ждем.
      case 51:
        if (timeWaitGPRS==0) flGPRSState=50;
        break;
      case 18: // Посылаем команду для подключения к серверу.
        if (NeedGPRS==0) break;
    
    #ifndef UDP_PROTOKOL     
        Serial2.println(String(F("at+tcpsendbuf=0,54")).c_str());
    #else
        Serial2.println(String(F("AT+UDPSENDBUF=0,54")).c_str());
    #endif

    #ifndef UDP_PROTOKOL     
        Serial2.println(String(F("AT+TCPCLOSE=0")).c_str());
    #else
        Serial2.println(String(F("AT+UDPCLOSE=0")).c_str());
    #endif
    
        flGPRSState=91;    
      case 91:
        flGPRSState=0; // Ничего не делаем, ждем.
        break;
   

      if (strstr(my_rx_buffer,String(F("+CIFSR:STAIP")).c_str())) // Информация о состоянии подключения wi-fi
      {  
    
        if (strstr(my_rx_buffer,String(F("0.0.0.0")).c_str()))  {  
          flGPRSState=168; 
          stateAfterDelete=156; 
          ErrGPRSConnectInernet++;
        } // Неуспешное подключение к wi-fi
        else  {
          flGPRSState=168;
          stateAfterDelete=158; 
          ErrGPRSConnectInernet=0;
        } //  Успешное подключение к wi-fi, переход к ожиданию ОК.
    
        if (ErrGPRSConnectInernet>40)
        {
    #ifdef TESTGSM
          Serial.print(String(F("Err conn failed Wi-FI:")).c_str());
          Serial.println((int)ErrGPRSConnectInernet);
    #endif
          flGPRSState=0;
        }
        else
          if (ErrGPRSConnectInernet>20)
          {
    #ifdef TESTGSM
            Serial.print(String(F("Err conn Wi-Fi:")).c_str());
            Serial.println((int)ErrGPRSConnectInernet);
    #endif
            flGPRSState=168; 
            stateAfterDelete=150;
          }
    
    #ifdef TESTGSM
        Serial.print(String(F("+CIFSR:STAIP")).c_str());
        Serial.println((int)flGPRSState);
    #endif
        return;
      }
    
    
    #ifndef UDP_PROTOKOL
      if (strstr(my_rx_buffer,String(F("+TCPSETUP:")).c_str())) // Информация о состоянии к серверу
    #else
        if (strstr(my_rx_buffer,String(F("+UDPSETUP:")).c_str())) // Информация о состоянии к серверу
    #endif  
    
        {
          if (strstr(my_rx_buffer,String(F(":0,OK")).c_str()))  { 
            flGPRSState=30; 
            ErrGPRSConnectServer=0;
          }// Успешно подключено к серверу
          else 
            if (strstr(my_rx_buffer,String(F(":Error")).c_str())) { 
            flGPRSState=50; 
            ErrGPRSConnectServer++;
          }// Ошибка подключения, закрываем соединение и пробуем еще раз
          else  
          { 
            flGPRSState=14; 
            ErrGPRSConnectServer++;
          }// Неуспешно подключено пробуем подключение еще раз.
    
          if (ErrGPRSConnectServer>20) 
          {
    #ifdef TESTGSM
            Serial.print(String(F("Error connect to Server count=")).c_str());
            Serial.println((int)ErrGPRSConnectServer);
    #endif
            flGPRSState=2;
          } 
    
          return;
        }
    
      if (strstr(my_rx_buffer,String(F("+IPSTATUS:")).c_str())) // Информация о состоянии к серверу
      {
        //            +IPSTATUS:0,CONNECT,TCP,2047
        if (strstr(my_rx_buffer,String(F(":0,CONNECT,")).c_str()))  { 
          flGPRSState=18; 
        }// Успешно подключено к серверу, можно отправлять данные. 
        else 
        { 
          flGPRSState=16;
        }// Неуспешно подключено пробуем подключение еще раз.
        return;
      }
    
      if (strstr(my_rx_buffer,String(F("+CIPSTATUS:")).c_str())) // Информация о состоянии к серверу для wi-fi
      {
        if (strstr(my_rx_buffer,String(F(":0,")).c_str()))  
        { 
          // состояние Ожидание ОК
          flGPRSState=167; 
        }// Успешно подключено к серверу, можно отправлять данные. 
        else 
        { 
          flGPRSState=160;
        }// Неуспешно подключено пробуем подключение еще раз.
        return;
      }
    
    
    #ifndef UDP_PROTOKOL
      if (strstr(my_rx_buffer,String(F("+TCPSEND:")).c_str())) // Информация о состоянии к серверу - отправка ошибка, проверяем коннект к серверу и пробуем еще.
    #else
        if (strstr(my_rx_buffer,String(F("+UDPSEND:")).c_str())) // Информация о состоянии к серверу - отправка ошибка, проверяем коннект к серверу и пробуем еще.
    #endif
        {
    
          if (strstr(my_rx_buffer,String(F(":Error")).c_str())) 
          {
            // Если ошибка, тогда идем на проверку связи
            flGPRSState=30; 
          }
          else
          {
            // Если состояние - сообщение отправлено, решаем что делать дальше
            if (flGPRSState==21) 
            { 
              if (flNeedRefrServer) 
              {  // Если это разовая отправка
                // Постоим в режиме ожидания, не разывая соединения, ожидая возможной команыд от серверка
                timeWaitGPRS=10;
                timeGPRS=5;
                flNeedRefrServer=0; // Снмаем флаг необходимости отправки сведений на сервер
                timeRefrServer=PeriodRefrServer;// Взводим таймер на следующую отправку
              }   
              else
                flGPRSState=25;  // Если отправка не разовая, тогда переводим в режим следующей отправки.
            }
          }
          return;
        }
    
    
      if (strstr(my_rx_buffer,String(F("SEND OK")).c_str())) // информация отправлена.
      {
    
        // Если состояние - сообщение отправлено, решаем что делать дальше
        if (flGPRSState==165) 
        { 
          if (flNeedRefrServer) 
          {  // Если это разовая отправка
            // Постоим в режиме ожидания, не разывая соединения, ожидая возможной команыд от серверка
            timeWaitGPRS=10;
            timeGPRS=5;
            flNeedRefrServer=0; // Снмаем флаг необходимости отправки сведений на сервер
            timeRefrServer=PeriodRefrServer;// Взводим таймер на следующую отправку
          }   
          else
            flGPRSState=162;  // Если отправка не разовая, тогда переводим в режим следующей отправки.
        }
        return;
      }
    
    
  
    #ifndef UDP_PROTOKOL
      if (strstr(my_rx_buffer,String(F("+TCPRECV:")).c_str())) // Информация о состоянии к серверу
    #else
        if (strstr(my_rx_buffer,String(F("+UDPRECV:")).c_str())) // Информация о состоянии к серверу
    #endif
        {
          // Команда состоит из двух частей первая - это символ команды, вторая это номер по порядку
          // например U1 - нажата кнопка вверх, номер команды 1
          cmdGPRS=my_rx_buffer[strlen(my_rx_buffer)-2];
    
          cmdGPRSIsp=my_rx_buffer[strlen(my_rx_buffer)-1]; // э
    
    #ifdef TESTGSM
          Serial.print(String(F("Get cmd keys:")).c_str());
          Serial.print(cmdGPRS);
          Serial.println(cmdGPRSIsp);
    #endif

    #ifndef UDP_PROTOKOL
      if (strstr(my_rx_buffer,String(F("+TCPCLOSE:")).c_str())) // Сервер отключился.
    #else
        if (strstr(my_rx_buffer,String(F("+UDPCLOSE:")).c_str())) // Сервер отключился.
    #endif
    
        {
          // Если находимся в режиме закрытия
          if (flGPRSState!=0) flGPRSState=16; // 
    #ifdef TESTGSM
          Serial.print(String(F("State +TCP_UDP_CLOSE:")).c_str());
          Serial.println((int)flGPRSState);
    #endif
          return;
    
        }
    
      if (strstr(my_rx_buffer,String(F("CLOSED")).c_str())) // Сервер отключился.
      {
        // Если находимся в режиме закрытия
        if (flGPRSState!=0) flGPRSState=160; // 
    #ifdef TESTGSM
        Serial.print(String(F("State WI-FI CLOSE:")).c_str());
        Serial.println((int)flGPRSState);
    #endif
        return;
      }
    }
  }
}      

#endif // #if USE_GSM_WIFI == 1

