// Последнее обновление 2017-08-15 by Phisik
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Здесь всяческий вывод на экран
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <OneWire.h>
#include <EEPROM.h> 

#include "configuration.h"
#include "declarations.h"

char flNumStrPrint=0;

void my_lcdprint(char *s)
{ 
  char i;
  char len;
  len=strlen(lcd_buffer);  
  for(i=len;i<16;i++) s[i]=' ';
  s[16]=0;

  if (IspReg==111 && s[9]=='R' && flNumStrPrint==0) s[9]='N';

  lcd.print(s);  

// MQTT code by max506 & limon
#if defined(USE_MQTT_BROKER) && (USE_MQTT_BROKER==1)

  if (flNumStrPrint==0) {
    
    sprintf(lcd_mqtt_buf1, GePMEM(buf_pmem,fmt_lcd1), s);
   
    // Убрать завершающие пробелы
    for(i=strlen(lcd_mqtt_buf1)-1; ;i--) {
      if (lcd_mqtt_buf1[i]==' ') lcd_mqtt_buf1[i]='\0';
      else break;
    }
  }
  else if (flNumStrPrint==1) {
 
    sprintf(lcd_mqtt_buf2, GePMEM(buf_pmem,fmt_lcd2), s);
   
    // Убрать завершающие пробелы
    for(i=strlen(lcd_mqtt_buf2)-1; ;i--) {
      if (lcd_mqtt_buf2[i]==' ') lcd_mqtt_buf2[i]='\0';
      else break;
    }    
 }

#endif // USE_MQTT_BROKER


#if USE_GSM_WIFI==1

      // Если состояние отправки - надо отправить экран, тогда отправляем еще и на сервер.
      if (flGPRSState==20 || flGPRSState==164)
      {
        if (flNumStrPrint==0)
        {   // Первой строчкой отправляем id устройства и первую строку экрана
          sprintf(my_gprs_buffer,String(F("%s;%s")).c_str(),idDevice,s); //запись в буфер текста и значений температуры в подготовленном
          Serial2.print(my_gprs_buffer);
    #ifdef TESTGSM
          Serial.println(String(F("SendDTA1:")).c_str());
          Serial.println(my_gprs_buffer);
    #endif
    
        }
        else
        {   // Второй строчкой отправляем нужную часть экрана, состояние контроллера и последнюю выполненную команду. 
          sprintf(my_gprs_buffer,String(F("%s;%3i;%3i;%c#")).c_str(),s,(int) IspReg,(int) StateMachine,cmdGPRSIsp);
          Serial2.println(my_gprs_buffer);
    #ifdef TESTGSM
          Serial.println(String(F("SendDTA2:")).c_str());
          Serial.println(my_gprs_buffer);
    #endif
          flGPRSState++; // Переводим контроллер в состояние отправлено.
          //timeWaitGPRS=20;
          timeWaitGPRS=2; // Две секунды достаточно для отправки
        }
      }
    
      flNumStrPrint++;
#endif


#ifdef TESTMEM
  Serial.println(String(F("\n[memCheck_print]")).c_str());
  Serial.println(freeRam());
#endif
}

unsigned char hour,minute,second;
int V1,V2,V3;

void formTRZGDistill()
{
  if (TempDeflBegDistil>0) sprintf(lcd_buffer,String(F("tD=%3i/%3i %4iW")).c_str(),temps[TEMP_DEFL],TempDeflBegDistil,Power);
  else  sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],-TempDeflBegDistil,Power);

}

void formTSAErr()
{
  sprintf(lcd_buffer,String(F("%02u:%02u:%02u TSA!")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
  //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
  my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
  sprintf(lcd_buffer,String(F("tT=%3i/%3i")).c_str(),temps[TEMP_TSA],MAX_TEMP_TSA); //запись в буфер текста и значений температуры в подготовленном
}

void DisplayRectif()
{
  if (DispPage==0) 
  {
    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Не запущено
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u Rect")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном

      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      //sprintf(lcd_buffer,String(F("tK=%3i P=%4i")).c_str(),temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 2: //Разгон
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R RZG")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      if (tEndRectRazgon>0) sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
      else sprintf(lcd_buffer,String(F("tN=%3i/%3i %4iW")).c_str(),temps[TEMP_RK20],-tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 3: //Стабилицация колонны
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R NSB")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tN=%3i(%3i)%4iW")).c_str(),temps[TEMP_RK20],(IspReg==111 ?(int)(SecOstatok):(int)(Seconds-SecTempPrev)),PowerRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 4: //Отбор голов
      if (IspReg!=118)
      {
        sprintf(lcd_buffer,String(F("%02u:%02u:%02u R GLV")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
        //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    

        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        if (UrovenProvodimostSR==0)
          sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],tEndRectOtbGlv,PowerRect); //запись в буфер текста и значений температуры в подготовленном
        else
          if (UrovenProvodimostSR>0)
          {
            if  (UrovenProvodimostSR==2) sprintf(lcd_buffer,String(F("Pr=%3i/%3i %4iW")).c_str(),U_GLV,UROVEN_ALARM,PowerRect); //запись в буфер текста и значений температуры в подготовленном
            else sprintf(lcd_buffer,String(F("Pr=%3i/%3i %4iW")).c_str(),U_GLV,UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
          }
          else
            sprintf(lcd_buffer,String(F("Tm=%3i/%3i %4iW")).c_str(),(int) SecOstatok,-UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
      }
      else
      {

        sprintf(lcd_buffer,String(F("%02u:%02u:%02u RF GLV")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
        if (TekFraction<CountFractionRect) V2=TempFractionRect[TekFraction];
        if (V2>=0) sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],V2,UstPower);
        else sprintf(lcd_buffer,String(F("t=%5imin %4iW")).c_str(),(int) SecOstatok,UstPower);

      }  
      break;
    case 5: //Стоп, ожидание возврата температуры
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R Stop")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tN=%3i/%3i %2i%%")).c_str(),temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 6: //Ректификация
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u RSt %2i%%")).c_str(),hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tN=%3i/%3i/d%2i")).c_str(),temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 7: //Отбор хвостов
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R Hvost")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i/%3i")).c_str(),temps[TEMP_KUB],IspReg!=118 ? tEndRect:TekTemp); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 8: //Отбор ожидание 3 минут
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R Wait")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i/%3i")).c_str(),temps[TEMP_KUB],IspReg!=118 ? tEndRect : TekTemp); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 9: //Ожидание датчика уровня
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u R Wait")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("by Urov=%3i/%3i")).c_str(),U_UROVEN,UROVEN_ALARM); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u Rec End")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i/%3i End")).c_str(),temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    case 102: //Давление
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u Pres")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
      sprintf(lcd_buffer,String(F("MPX5010=%3i/%3i")).c_str(),U_MPX5010,AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;

    }
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    if (StateMachine!=5) 
    {   
      if (IspReg!=118)  sprintf(lcd_buffer,String(F("%3immV=%4u,%4u")).c_str(),U_MPX5010,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
      else 
        if (TekFraction<CountFractionRect)
      {
        if (TempFractionRect[TekFraction]>0) 
          sprintf(lcd_buffer,String(F("%3imm t=%3i F%1i/%1i")).c_str(),U_MPX5010,TempFractionRect[TekFraction],(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
        else
          sprintf(lcd_buffer,String(F("%3imm %4im F%1i/%1i")).c_str(),U_MPX5010,(int) SecOstatok,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
      }
      else
        sprintf(lcd_buffer,String(F("%3immV=%4u F%1i/%1i")).c_str(),U_MPX5010,U_UROVEN,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
    }
    else sprintf(lcd_buffer,String(F("%3imm reSt=%5i")).c_str(),U_MPX5010,time1); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayDistDefl()
{
  if (DispPage==0) 
  {
    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD Rzg")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tD=%3i/%3i %4iW")).c_str(),temps[TEMP_DEFL],TempDeflBegDistil,UstPower); 
      break;
    case 3: //Ожидание закипания (прогреется куб дефлегматор)
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD Rzg")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],TempDeflBegDistil,UstPower); 
      break;
    case 4: //Работа без дефлегматора
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD BezD")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tD=%3i/%3i %4iW")).c_str(),temps[TEMP_DEFL],TempDefl,UstPower); 
      break;
    case 5: //Работа с 50% дефлегмацией
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD 50%%")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tD=%3i/%3i %4iW")).c_str(),temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
      break;
    case 6: //Работа с 100% дефлегмацией
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD 100%%")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tD=%3i/%3i %4iW")).c_str(),temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
      break;
    case 7: //Ожидание для охлаждения
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD Wait")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i Wait=%4i")).c_str(),temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DD end")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i end")).c_str(),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,String(F("V%4u,%4u-%4iW")).c_str(),U_VODA,U_UROVEN,deltaPower); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplaySimpleDistill()
{
  if (DispPage==0) 
  {
    if (IspReg==104) 
    { 
      V1=1;
      V2=Temp1P;   
    }
    if (IspReg==106) 
    { 
      V1=2;
      V2=Temp2P;   
    }
    if (IspReg==107   || IspReg==105 ) 
    { 
      V1=3;
      V2=Temp3P;   
    }

    if (IspReg!=105)  sprintf(lcd_buffer,String(F("%02u:%02u:%02u %1u-Otbor")).c_str(),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
    else  sprintf(lcd_buffer,String(F("%02u:%02u:%02u sGl")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном

    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      if (IspReg!=105)  sprintf(lcd_buffer,String(F("%02u:%02u:%02u %1u-O Rzg")).c_str(),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
      else sprintf(lcd_buffer,String(F("%02u:%02u:%02u sGl Rzg")).c_str(),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 3: //Дистилляция
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],V2,UstPower); 
      break;
    case 4: //Ожидание 60 секунд для охлаждения
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i Wait=%4i")).c_str(),temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i end")).c_str(),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;                        
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,String(F("V%4u,%4u %4uW")).c_str(),U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
  }

}
void DisplayFracionDistill()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,String(F("%02u:%02u:%02u DsF %1i/%1i")).c_str(),hour,minute,second,(int) (TekFraction<CountFractionDist) ? TekFraction+1: CountFractionDist,(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном

    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      sprintf(lcd_buffer,String(F("%02u:%02u:%02u DsF Rzg")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 3: //Дистилляция
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

      if (TekFraction<CountFractionDist) V2=TempFractionDist[TekFraction];
      if (V2>=0) sprintf(lcd_buffer,String(F("tK=%3i/%3i %4iW")).c_str(),temps[TEMP_KUB],V2,UstPower);
      else sprintf(lcd_buffer,String(F("t=%5imin %4iW")).c_str(),(int) SecOstatok,UstPower);

      break;
    case 4: //Ожидание 60 секунд для охлаждения
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i Wait=%4i")).c_str(),temps[TEMP_KUB],time3); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("tK=%3i end")).c_str(),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;                        
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,String(F("V%4u,%4u %4uW")).c_str(),U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayTestKLP()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,String(F("%02u:%02u:%02u tst Dev")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("St=%3i CHIM=%3i")).c_str(),StateMachine,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,String(F("%3u,%3u Gas=%4u")).c_str(),temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayExtContol()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,String(F("%02u:%02u:%02u ExtCtrl")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    //sprintf(lcd_buffer,String(F("%u%u%u%u  %u%u%u%u")).c_str(),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("T=%3u,%3u %4iW")).c_str(),temps[0],temps[1],UstPower); //запись в буфер текста и значений температуры в подготовленном
  }
  else
  {
    sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,String(F("%3u,%3u Gas=%4u")).c_str(),temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayData()
{
  int tic1;
  static int PrevState=0;
  static char flDspDop=0; // Флаг для отображения информации (через раз)
  char j; // Временная переменная для цикла
  flNumStrPrint=0;
  flDspDop=!flDspDop;

  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  second=tic1 % 60;   

  if (FlState==0) 
    lcd.setCursor(0, 0);
  else 
  { 
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState==0)  delay(100);

    if (FlState!=PrevState)
    {
      lcd.clear();  //очистка дисплея   
      PrevState=FlState;
    }

    lcd.setCursor(0, 0);
  }

#ifdef TESTMEM
  Serial.println(String(F("\n[memCheck_displ]")).c_str());
  Serial.println(freeRam());
#endif

  switch (FlState)
  {
  case 0:

    if (DispPage<2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
    {
      switch (IspReg)
      {
      case 101: // Displaying
        //sprintf(lcd_buffer,String(F("S=%5u TT=%5u")).c_str(),Seconds,MaxTimeTimer); //запись в буфер текста и значений температуры в подготовленном

        //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
        //  это напряжение нужно для калибровки нашего измерителя

        if (DispPage==0) 
        {
          sprintf(lcd_buffer,String(F("%02u:%02u:%02u DSP 1/2")).c_str(),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,String(F("Zr=%4u U=%3i")).c_str(),TicZero,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
        }

        if (DispPage==1) 
        {
          sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,String(F("V=%4u,%4u,%4u")).c_str(),U_VODA,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
        }
        //          lcd.setCursor(0, 1);
        //          my_lcdprint(lcd_buffer);                      

        break;
      case 102: // Термостат         
        if (DispPage==0) 
        {
          sprintf(lcd_buffer,String(F("%02u:%02u:%02u TermSt")).c_str(),hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          sprintf(lcd_buffer,String(F("t=%3i/%3i(%2i) %1i")).c_str(),temps[TEMP_TERMOSTAT],TempTerm,Delta,StateMachine); //запись в буфер текста и значений температуры в подготовленном
        }
        else
        {
          sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,String(F("%3u,%3u P=%3imm")).c_str(),temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
        }
        break;
      case 115: // Таймер
        if (DispPage==0) 
        {
          sprintf(lcd_buffer,String(F("%02u:%02u:%02u Timer")).c_str(),hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          minute=Seconds / 60;
          sprintf(lcd_buffer,String(F("tm=%3i/%3i %4iW")).c_str(),minute,timerMinute,UstPower); //запись в буфер текста и значений температуры в подготовленном
        }
        else
        {
          sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,String(F("%3u,%3u %4iW")).c_str(),temps[3],temps[4],PowerMinute); //запись в буфер текста и значений температуры в подготовленном
        }
        break;
      case 103: // Регулятор мощности
        if (DispPage==0) 
        {
#ifndef USE_SLAVE
          sprintf(lcd_buffer,String(F("%02u:%02u:%02u RMU=%3u")).c_str(),hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

#ifdef TEST
          if (NUM_PHASE>1) sprintf(lcd_buffer,String(F("%s")).c_str(),my_rx_buffer); //запись в буфер текста и значений температуры в подготовленном
#endif
#else
          sprintf(lcd_buffer,String(F("%02u:%02u:%02u RMU=%3u")).c_str(),hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          sprintf(lcd_buffer,String(F("PSlv=%4u/%4u")).c_str(),UstPower,Power); //запись в буфер текста и значений температуры в подготовленном
#endif
        }
        else
        {
          sprintf(lcd_buffer,String(F("D2 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
#ifndef USE_SLAVE
          sprintf(lcd_buffer,String(F("Up to auto=%4uW")).c_str(),Power); //запись в буфер текста и значений температуры в подготовленном
#else
          if (flAutoDetectPowerTEN)
            sprintf(lcd_buffer,String(F("Up to auto=%4uW")).c_str(),Power); //запись в буфер текста и значений температуры в подготовленном
          else
            sprintf(lcd_buffer,String(F("SlaveOn (Up)=%1i")).c_str(),(int) SlaveON); //запись в буфер текста и значений температуры в подготовленном
#endif
        }
        break;
      case 105: // Отбор голов33
        //          DisplaySimpleGLV();
        //          break;
      case 104: // Перевый (недробный) отбор
      case 106: // Второй дробный отбор
      case 107: // Третий дробный отбор
        DisplaySimpleDistill();
        break;

      case 117: // Фракционная перегонка
        DisplayFracionDistill();
        break;
      case 109: // Ректификация
      case 118: // Ректификация
        DisplayRectif();
        break;
#ifndef TEST
#ifndef DEBUG // Это отображение информации выкусываем, если в режиме теста, потому что не хватает памяти
#ifndef TESTGSM
#ifndef TESTGSM1
      case 110: // Дистилляция с дефлегматором
        DisplayDistDefl();
        break;
#endif
#endif
#endif
#endif
      case 130: // Внешнее управление
        DisplayExtContol();
        break;
      case 129: // тест клапанов
        DisplayTestKLP();
        break;
      case 248:
        //          sprintf(lcd_buffer,String(F("LOW LEVEL VOLTS!")).c_str()); //запись в буфер текста и значений температуры в подготовленном
        //          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        //          sprintf(lcd_buffer,String(F("Umax=%i Sec=%3i")).c_str(),MaxVoltsOut,(int) ErrCountIndex*12); //запись в буфер текста и значений температуры в подготовленном
        break;
      case 249:
        sprintf(lcd_buffer,String(F("NO DETECT ZERO!")).c_str()); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,String(F("Umax=%i")).c_str(),MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
        break;
      case 250:
        sprintf(lcd_buffer,String(F("ALARM VODA !")).c_str()); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 251:
        sprintf(lcd_buffer,String(F("ERR Ds18b20!")).c_str()); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,String(F("Num=%i")).c_str(),(int) NumErrDs18); //запись в буфер текста и значений температуры в подготовленном

        break;
      case 252:
        sprintf(lcd_buffer,String(F("ALARM GAS SENS!")).c_str()); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;

      }   
      // Это обычное состояние

    }
    // Третья страница отображения универсальна, там показываем напряжение, дистанцию и возможное число ошибок
    // расчета среднеквадратичного. 

    if (DispPage==2)
    {
      #if USE_GSM_WIFI==1
          sprintf(lcd_buffer,String(F("D3 %3i,w%3u,i%3i")).c_str(),(int)flGPRSState,(int)timeWaitGPRS,(int)timeGPRS); 
          my_lcdprint(lcd_buffer);
      #else
//          my_lcdprint(String(F("D3 No GSM Supp.")).c_str());
      #endif

      sprintf(lcd_buffer,String(F("%4iW,%3uV,%3uA")).c_str(),FactPower,MaxVoltsOut,MaxIOut); //запись в буфер текста и значений температуры в подготовленном
    }
    // На четвертой странице показываем всю температуру и давление
    if (DispPage==3)
    {
      sprintf(lcd_buffer,String(F("D4 T=%3i,%3i,%3i")).c_str(),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("%3i,%3i P=%3imm")).c_str(),temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    }

    // На пятой странице показываем состояние датчиков уровней
    if (DispPage==4)
    {
      sprintf(lcd_buffer,String(F("D5 VODA=%4u")).c_str(), U_VODA); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("URV=%4u GL=%4u")).c_str(),U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
    }

    // На шестой странице показываем состояние датчиков уровней
    if (DispPage==5)
    {
      sprintf(lcd_buffer,String(F("D6 GAS=%4u")).c_str(), U_GAS); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("zPS=%3u,%4uW")).c_str(),(int) zPSOut,UstPwrPH1); //запись в буфер текста и значений температуры в подготовленном
    }

    // На седьмой странице показываем состояние регулятора мощности
    if (DispPage==6)
    {
#if NUM_PHASE==1
      sprintf(lcd_buffer,String(F(" %4i,%4i,%4iW")).c_str(),UstPwrPH1,UstPwrPH2,UstPwrPH3); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("D7 %3i,%3i,%3i %%")).c_str(),KtPhase[0],KtPhase[1],KtPhase[2]); //запись в буфер текста и значений температуры в подготовленном
#else
      sprintf(lcd_buffer,String(F("D7 T=%4u,Z=%4u")).c_str(), TimeOpenTriac,TicZero); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("KLP=%4u,Bz=%3u")).c_str(),TimeOpenKLP,(int)b_value[0]); //запись в буфер текста и значений температуры в подготовленном
#endif
    }

    // На восьмой можно сменить состояние процесса.
    if (DispPage==7)
    {
      sprintf(lcd_buffer,String(F("D8 State Debug")).c_str()); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("StateMacine=%i")).c_str(),(int)StateMachine); //запись в буфер текста и значений температуры в подготовленном
    }

    // На девятой состояние ПИД-регулятора
    if (DispPage==8)
    {
      sprintf(lcd_buffer,String(F("D9 N=%4i O=%4i")).c_str(),NewErr,OldErrOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("Dt=%4i It=%4i")).c_str(),Dt,It); //запись в буфер текста и значений температуры в подготовленном
    }
    // На Десятой странице показываем максимальные температуры за процесс температуру и давление
    if (DispPage==9)
    {
      sprintf(lcd_buffer,String(F("D10 MaxT=%3i,%3i")).c_str(),Maxtemps[0],Maxtemps[1]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("%3i,%3i,%3i")).c_str(),Maxtemps[2],Maxtemps[3],Maxtemps[4]); //запись в буфер текста и значений температуры в подготовленном
    }
    // На 11  странице показываем параметры расчета ПИД-регулятора
    if (DispPage==10)
    {
      sprintf(lcd_buffer,String(F("D11 N,O=%3i %3i")).c_str(),NewErrTemp,OldErrTempOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,String(F("KId%4i %4i %3i")).c_str(),KtT,ItTemp,DtTemp); //запись в буфер текста и значений температуры в подготовленном
    }

    if (flDspDop && DispDopInfo>0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
    {

      if (BeepStateProcess>1) 
      {
        if (DispDopInfo==3 || DispDopInfo==4)
        {
          if (!(BeepStateProcess&B00000010) && DispDopInfo==3) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
          if (!(BeepStateProcess&B00000100) && DispDopInfo==4) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
        }
        else
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
      }
      else
        my_beep(BEEP_LONG); // Сначала пищим, предупреждая.


      if(DispDopInfo==1) sprintf(lcd_buffer,String(F("Smena TARA!(%3i)")).c_str(),(IspReg==117 || IspReg==118) ? COUNT_ALARM_UROVEN_FR-CountAlarmUroven :COUNT_ALARM_UROVEN-CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==2) sprintf(lcd_buffer,String(F("VODA! (%3i)")).c_str(),COUNT_ALARM_VODA-CountAlarmVoda); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==3) sprintf(lcd_buffer,String(F("Low Power! %3iV")).c_str(),MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==6) sprintf(lcd_buffer,String(F("HIGH Power! %3iV")).c_str(),MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==4) sprintf(lcd_buffer,String(F("Err temp! ds=%2i")).c_str(),(int) NumErrDs18 ); //Выводим на экран инфомацию о ошибке чтения датчика.
      if(DispDopInfo==5) sprintf(lcd_buffer,String(F("!PRESS=%3i/%3i")).c_str(),U_MPX5010,AlarmMPX5010); //Выводим на экран инфомацию о ошибке чтения датчика.

      #if USE_GSM_WIFI==1
            // Активизируем разовую отправку состояния на сервер
            if (FlToGSM>1 && flGPRSState!=20  && flGPRSState!=164 && (timeGPRS==0 || flNeedCall==1) )
            {
              if (flNeedCall==1) 
              { 
                flGPRSState=40; // Активируем звонок если в этом есть необходимость
              }
              else  
              {   // Если в данный момент не производится дозвон, тогда активируем GPRS сессию. 
                if (flNeedCall!=2) flGPRSState=2;
              }
              // Активируем длительную сессию GPRS
              flNeedRefrServer=0;
              timeGPRS=250;
            }
      #endif
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 100:
    sprintf(lcd_buffer,String(F("Settings Menu")).c_str(), FlState); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 101:
    sprintf(lcd_buffer,String(F("IsR = Displaying")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 102:
    sprintf(lcd_buffer,String(F("IsR = Termostat")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 103:
    sprintf(lcd_buffer,String(F("IsR = Reg Power")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 104:
    sprintf(lcd_buffer,String(F("IsR = 1 ND otbor")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 105:
    sprintf(lcd_buffer,String(F("IsR = otbor GLV")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 106:
    sprintf(lcd_buffer,String(F("IsR = 2 DR otbor")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 107:
    sprintf(lcd_buffer,String(F("IsR = 3 DR otbor")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 109:
    sprintf(lcd_buffer,String(F("IsR = Rectif")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 110:// Дистилляция с дефлегматором
    sprintf(lcd_buffer,String(F("IsR = Dist Defl")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 115:// Таймер
    sprintf(lcd_buffer,String(F("IsR = Timer")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("ust Power")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
 case 117:// Фракционная дистилляция
    sprintf(lcd_buffer,String(F("IsR = Distill")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Fractional")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 118:// Фракционная ректификация
    sprintf(lcd_buffer,String(F("IsR = Rectif")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Fractional")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 130:
    sprintf(lcd_buffer,String(F("IsR = External")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Control")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 129:
    sprintf(lcd_buffer,String(F("IsR = Test")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Device (%i)")).c_str(),FlState); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 200:
    sprintf(lcd_buffer,String(F("Max_t_Tst=%5i")).c_str(),TempTerm); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 201:
    sprintf(lcd_buffer,String(F("Power TEN=%5u")).c_str(),Power); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 202:
    sprintf(lcd_buffer,String(F("Power Reg=%5u")).c_str(),UstPowerReg); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 203:
    sprintf(lcd_buffer,String(F("ParamUSART=%u")).c_str(),FlToUSART); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 204:
    sprintf(lcd_buffer,String(F("ParamGSM=%u")).c_str(),FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if(FlToGSM==1 || FlToGSM==0) sprintf(lcd_buffer,String(F("GSM")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==2) sprintf(lcd_buffer,String(F("GPRS Megafon")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==3) sprintf(lcd_buffer,String(F("GPRS BeeLine")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==4) sprintf(lcd_buffer,String(F("GPRS MTS")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==5) sprintf(lcd_buffer,String(F("GPRS Rostelecom")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==6) sprintf(lcd_buffer,String(F("GPRS Tele 2")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM>=7) sprintf(lcd_buffer,String(F("GPRS Reserv %i")).c_str(), (int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==10) sprintf(lcd_buffer,String(F("Wi-Fi")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==11) sprintf(lcd_buffer,String(F("Android ext")).c_str()); //запись в буфер текста и значений температуры в подготовленном
//    if(FlToGSM==12) sprintf(lcd_buffer,String(F("Android int")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM>12) sprintf(lcd_buffer,String(F("Err! 0..11 (%i)")).c_str(),(int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 205:
    sprintf(lcd_buffer,String(F("dtTermostat=%3i")).c_str(),Delta); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 206:
    sprintf(lcd_buffer,String(F("Temp 1 Nedrobn")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Distill=%3i")).c_str(),Temp1P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 207:
    sprintf(lcd_buffer,String(F("Temp 2 Drobn")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Distill=%3i")).c_str(),Temp2P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 208:
    sprintf(lcd_buffer,String(F("Temp 3 Drobn")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Distill=%3i")).c_str(),Temp3P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 209:
    sprintf(lcd_buffer,String(F("Temp Razgon Rect")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("(+Kub,-Kol)=%3i")).c_str(),tEndRectRazgon); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 210:
    sprintf(lcd_buffer,String(F("Power")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%3i")).c_str(),PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 211:
    sprintf(lcd_buffer,String(F("Vvod Popravok")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("ds18b20 ")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 212:
    sprintf(lcd_buffer,String(F("Temp Okon Otbor")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Glv Rectif=%3i")).c_str(),tEndRectOtbGlv ); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 213:
    sprintf(lcd_buffer,String(F("CHIM Otbor GLV")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%5u")).c_str(),timeChimRectOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 214:
    sprintf(lcd_buffer,String(F("%% CHIM Otbor GLV")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%3i")).c_str(),(int) ProcChimOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 215:
    sprintf(lcd_buffer,String(F("CHIM Otbor SR")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%5u")).c_str(),timeChimRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 216:
    sprintf(lcd_buffer,String(F("Delta Otbor SR")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%3u")).c_str(),tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 217:
    sprintf(lcd_buffer,String(F("Temp Okon Otbor")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("SR Rectif=%3i")).c_str(),tEndRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 218:
    sprintf(lcd_buffer,String(F("Temp Okon")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%3i")).c_str(),tEndRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 250:
    sprintf(lcd_buffer,String(F("min %% CHIM")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F(" Otbor SR=%2i")).c_str(),minProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 251:
    sprintf(lcd_buffer,String(F("Edit Temp Stab")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Rectif=%3i")).c_str(),tStabSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 252:
    sprintf(lcd_buffer,String(F("Beg %% CHIM")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F(" Otbor SR=%2i")).c_str(),begProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 253:
    sprintf(lcd_buffer,String(F("Popr MPX=%4i")).c_str(),P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%4i/%4i")).c_str(),U_MPX5010,U_MPX5010+P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 219:
    sprintf(lcd_buffer,String(F("Power GLV simple")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Distill=%4i")).c_str(),PowerGlvDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 220:
    sprintf(lcd_buffer,String(F("Power simple")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Distill=%4i")).c_str(),PowerDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 221:
    sprintf(lcd_buffer,String(F("Temp Begin Dist")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("(+Def -Kub)=%3i")).c_str(),TempDeflBegDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 222:
    sprintf(lcd_buffer,String(F("Temp Distill")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("With Defl=%3i")).c_str(),TempDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 223:
    sprintf(lcd_buffer,String(F("Delta Distill")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("With Defl=%3i")).c_str(),DeltaDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 224:
    sprintf(lcd_buffer,String(F("Temp Kub Okon")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("DistWithDefl=%3i")).c_str(),tEndDistDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 225:
    sprintf(lcd_buffer,String(F("BeepEndProc=%1u")).c_str(),BeepEndProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 226:
    sprintf(lcd_buffer,String(F("BeepStateProc=%1u")).c_str(),BeepStateProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 227:
    sprintf(lcd_buffer,String(F("BeepKeyPress=%1u")).c_str(),BeepKeyPress); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 230:
    sprintf(lcd_buffer,"Period Refresh");
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Server(sec)=%3u")).c_str(),(unsigned int) PeriodRefrServer); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
    break;
  case 231:
    sprintf(lcd_buffer,String(F("U Peregrev=%3uV")).c_str(),(unsigned int) NaprPeregrev); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 233:
    sprintf(lcd_buffer,String(F("Provod SR=%4i")).c_str(),UrovenProvodimostSR); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 234:
    sprintf(lcd_buffer,String(F("Time Stab (+/-)")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Kolonna=%5isec")).c_str(),TimeStabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 235:
    sprintf(lcd_buffer,String(F("Edit T & CHIM")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Count CHIM=%3i")).c_str(),(int) CntCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 236:
    sprintf(lcd_buffer,String(F("Auto - CHIM=%3i")).c_str(),(int)DecrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 237:
    sprintf(lcd_buffer,String(F("Auto + CHIM=%3i")).c_str(),(int)IncrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 238:
    sprintf(lcd_buffer,String(F("Time Auto +")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("CHIM=%5isec")).c_str(),TimeAutoIncCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 239:
    sprintf(lcd_buffer,String(F("Time reStab(+/-)")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Kolonna=%5isec")).c_str(),TimeRestabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 241:
    sprintf(lcd_buffer,String(F("Power correct")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("ASC712 =%3i")).c_str(),(int) CorrectASC712); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 242:
    sprintf(lcd_buffer,String(F("Server adr=")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%3u.%3u.%3u.%3u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 243:
    sprintf(lcd_buffer,String(F("Server port=")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%u")).c_str(),ipPort); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 244:
    sprintf(lcd_buffer,String(F("ID Device=")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%s")).c_str(),idDevice); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 246:
    sprintf(lcd_buffer,String(F("Alarm Pressure")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("MPX5010=%i")).c_str(),AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 247:
    sprintf(lcd_buffer,String(F("Use Avtonom")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("HLD=%i")).c_str(),FlAvtonom); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 249:
    sprintf(lcd_buffer,String(F("PID Paramters")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%4i %4i %4i")).c_str(),(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 255:
    sprintf(lcd_buffer,String(F("Wi-Fi AP=")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%s")).c_str(),WiFiAP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 256:
    sprintf(lcd_buffer,String(F("Wi-Fi Password=")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%s")).c_str(),WiFiPass); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 257:
    sprintf(lcd_buffer,String(F("Fraction Dist")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Count =%3i")).c_str(),(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 258:
    sprintf(lcd_buffer,String(F("Fraction Rectif")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Count =%3i")).c_str(),(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 268:
    sprintf(lcd_buffer,String(F("%% otbor Tsarga")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Paster(+/-)=%3i")).c_str(),(int)ProcChimOtbCP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 300:
    sprintf(lcd_buffer,String(F("Temp%1i=%3u")).c_str(),nPopr,temps[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("Popr=%3i T=%3u")).c_str(),ds1820_popr[nPopr], (temps[nPopr]+ds1820_popr[nPopr])); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 301:
    sprintf(lcd_buffer,String(F("TempK(%1i)=%4i")).c_str(),(int) nPopr, tempK[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==0) 
    {  
      sprintf(lcd_buffer,String(F("%s %c")).c_str(),lcd_buffer,'*');
    }

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("CHIM(%1i)=%3i")).c_str(), (int) nPopr, (int) CHIM[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==1) 
    {  
      sprintf(lcd_buffer,String(F("%s %c")).c_str(),lcd_buffer,'*');
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
/*  case 302:
    // Первое значение это время работы насоса
    if (nPopr==0) 
      sprintf(lcd_buffer,String(F("Work Pump =%2im")).c_str(),(int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
      sprintf(lcd_buffer,String(F("TemP(%1i)=%3i.0")).c_str(),(int) nPopr, (int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном

    if (flPopr==0) 
    {  
      sprintf(lcd_buffer,String(F("%s %c")).c_str(),lcd_buffer,'*');
    }

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if (nPopr==0) 
      sprintf(lcd_buffer,String(F("Pause Pump=%2im")).c_str(),(int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
      sprintf(lcd_buffer,String(F("TimP(%1i)=%3i m")).c_str(), (int) nPopr, (int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном

    if (flPopr==1) 
    {  
      sprintf(lcd_buffer,String(F("%s %c")).c_str(),lcd_buffer,'*');
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
*/    
  case 303:
    sprintf(lcd_buffer,String(F("%3u.%3u.%3u.%3u")).c_str(),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=-1;
    while (j<nPopr*4)
    {
      j++;
      lcd_buffer[j]=' ';
    }
    lcd_buffer[j+1]='*';
    lcd_buffer[j+2]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 304:
    sprintf(lcd_buffer,String(F("%s (%3u)")).c_str(),idDevice,(unsigned int)idDevice[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 309:
    sprintf(lcd_buffer,String(F("%4i %4i %4i")).c_str(),(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer,String(F("   P")).c_str());
    if (nPopr==1) sprintf(lcd_buffer,String(F("        I")).c_str());
    if (nPopr==2) sprintf(lcd_buffer,String(F("             D")).c_str());
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;

  case 310:
    sprintf(lcd_buffer,String(F("%s /%3u")).c_str(),WiFiAP,(unsigned int)WiFiAP[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 311:
    sprintf(lcd_buffer,String(F("%s /%3u")).c_str(),WiFiPass,(unsigned int)WiFiPass[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 312:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_DIST)
    { 
      sprintf(lcd_buffer,String(F("Fraction Dist")).c_str()); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("Test =%3i")).c_str(),(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
      if (TempFractionDist[nPopr]>=0)
        sprintf(lcd_buffer,String(F("tFrDst(%1i)=%4i")).c_str(),(int) nPopr+1, (int) TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,String(F("timFD(%1i)=%5im")).c_str(),(int) nPopr+1, (int) -TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном        

      if (flPopr==0) 
      {  
        sprintf(lcd_buffer,String(F("%s%c")).c_str(),lcd_buffer,'*');
      }

      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

      if (flPopr==1)  sprintf(lcd_buffer,String(F("Angl=%3i*,%4iW")).c_str(),(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else  sprintf(lcd_buffer,String(F("Angl=%3i ,%4iW")).c_str(),(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном 

      if (flPopr==2)  sprintf(lcd_buffer,String(F("%s%c")).c_str(),lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 313:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_RECT)
    { 
      sprintf(lcd_buffer,String(F("Fraction Rect")).c_str()); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("Test =%3i")).c_str(),(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
      if (TempFractionRect[nPopr]>=0)
        sprintf(lcd_buffer,String(F("tFrRect(%1i)=%4i")).c_str(),(int) nPopr+1, (int) TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,String(F("timFR(%1i)=%5im")).c_str(),(int) nPopr+1,(int) -TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном        

      if (flPopr==0) 
      {  
        sprintf(lcd_buffer,String(F("%s%c")).c_str(),lcd_buffer,'*');
      }

      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,String(F("Angle=%3i")).c_str(),(int) AngleFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном 

      if (flPopr==1)  sprintf(lcd_buffer,String(F("%s%c")).c_str(),lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 314:
    sprintf(lcd_buffer,String(F("%4i %4i %4i")).c_str(),(int)PowerPhase[0],(int)PowerPhase[1],(int)PowerPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer,String(F(" PH1")).c_str());
    if (nPopr==1) sprintf(lcd_buffer,String(F("      PH2")).c_str());
    if (nPopr==2) sprintf(lcd_buffer,String(F("           PH3")).c_str());
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 315:
    sprintf(lcd_buffer,String(F("%3i %3i %3i=%3i")).c_str(),(int)KtPhase[0],(int)KtPhase[1],(int)KtPhase[2],(int)KtPhase[0]+KtPhase[1]+KtPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer,String(F("PH1")).c_str());
    if (nPopr==1) sprintf(lcd_buffer,String(F("    PH2")).c_str());
    if (nPopr==2) sprintf(lcd_buffer,String(F("        PH3")).c_str());
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  default:
    break;
  }

  if (flNumStrPrint<2) 
  {
    lcd_buffer[0]=0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  }
  NeedDisplaying=false;

}
